#include <malloc.h>
#include <memory.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <fcntl.h>

#include "ET199_32.h"

/**
 * @brief оӵļ豸
 * @return 豸
 * @retval -1 
 * @retval 0  δκصļ豸
 */
int initCtxDeviceList( ET_CONTEXT **ppContextList  ) {


    DWORD dwCtxListSize = 0 ;
    DWORD dwResult = 0 ;
    PET_CONTEXT pContextList = *ppContextList ;

    /**<  豸бΪգͷ豸б  */
    if ( pContextList != NULL ) {
        free( pContextList ) ;
        pContextList = NULL ;
    }
    /**< õӵ豸 */
    dwResult = ETEnum(NULL, &dwCtxListSize);
    if (dwResult != 0 && dwResult != ET_E_INSUFFICIENT_BUFFER) {
        printf("Enumerate device failed! <error code: 0x%08x>\n", dwResult);
        return -1;
    }

    if (0 == dwCtxListSize) {
        printf("No device present!\n");
        return 0;
    }

    /**< Ϊ豸ڴ  */

    pContextList = (ET_CONTEXT*)malloc(dwCtxListSize * sizeof(ET_CONTEXT) +10);
    if (NULL == pContextList) {
        printf("malloc failed! \n");
        return -1;
    }

    /**< 豸б */
    dwResult = ETEnum(pContextList, &dwCtxListSize);
    if (0 != dwResult) {
        printf("Enumerate device failed with error code:%d\n",dwResult);
        free( pContextList ) ;
        pContextList = NULL ;
        return -1;
    }
    
    *ppContextList = pContextList ;
    /**< 豸 */
	return  dwCtxListSize;
}

/**
 * @brief   תΪHEXַ
 * @param   pBuffer   , 
 *          len       , 
 * @return  HEXַ
 * @note  ĻȲܳ100
 */
BYTE* bufferToHexString( BYTE * pBuffer ,  int len ) {
    static char tempbuf[300];
    int i = 0 ;
    memset( tempbuf , 0 , sizeof(tempbuf)  ) ;
    if ( len > ( sizeof(tempbuf) / 2 -2 ) )
        len = ( sizeof(tempbuf) / 2 - 2 ) ;

    for ( i = 0; i < len ; i++) {
        sprintf(tempbuf+i*2 ,"%.2x ",pBuffer[i]);
    }
    return tempbuf;
}

/**
 * @brief   ͷ豸б
 *
 */
void freeCtxDeviceList( ET_CONTEXT * pContextList ) {
    if ( NULL != pContextList )
        free( pContextList ) ;
    pContextList = NULL ;
}

/**
 * @brief   ָλõ豸
 *
 * @return 0  ɹ , -1 ʧ .
 *
 */
BYTE  openDevice( int  index ,  ET_CONTEXT* pCtx  ) {
    PET_CONTEXT pContextList = NULL ; //豸б
    int  nDeviceNum = 0 ;
    int  nResult = 0 ;

    /**< ʼ豸б */
    nDeviceNum =  initCtxDeviceList( &pContextList ) ;
    if ( nDeviceNum <=  index || index < 0  ) {
        printf("No device present by index %d !\n" , index ) ;
        freeCtxDeviceList ( pContextList ) ;
        return  -1 ;
    }
    /**<  õָλõ豸Ϣ  */
    memcpy( pCtx ,  pContextList + index , sizeof( ET_CONTEXT ) ) ;

    /**< ͷб  */
    freeCtxDeviceList( pContextList  ) ;

    /**< 豸  */
    nResult = ETOpen(  pCtx  ) ;
    if ( 0 != nResult ) {
        printf("ETOpen for device NO %d  failed with error code:%d\n",  index  , nResult  ) ;
        return -1 ;
    }
    return 0 ;

}

/**
 * @brief  PCļ豸
 *
 * @param pCtx ,  豸Ϣ
 * @param lpDeviceFileID , 豸ҪļID
 * @param dwDeviceFileType , 豸Ҫļ
 * @param lpszPCFilePath , PCϵļ·
 * @return 0 , ɹ ;
 * @retval 
 * @see
 */

DWORD  loadFileIntoDevice ( ET_CONTEXT *pCtx, LPCSTR lpDeviceFileID ,  BYTE dwDeviceFileType ,  LPCSTR lpszPCFilePath ) {

    int fHandle;
    DWORD dwFileSize = 0 ;
    BYTE lpBuffer[65536];
    DWORD dwResult = 0 ;
    /**<  PCļ  */
    fHandle = _open( lpszPCFilePath , _O_RDONLY|_O_BINARY ) ;
    if ( fHandle == -1 ) {
        return ET_E_GENERAL_FILESYSTEM ;
    }

    if ( ( dwFileSize = _read( fHandle , lpBuffer , 65536 ) ) <= 0 ) {
        _close( fHandle ) ;
        return ET_E_GENERAL_FILESYSTEM ;
    }

    /**< 豸дļ  */
    dwResult = ETCreateFile( pCtx , lpDeviceFileID ,dwFileSize , dwDeviceFileType);
    if ( dwResult  != 0 ) {
        return dwResult ;
    }
    /**< дݵ豸ļ */
    dwResult = ETWriteFile( pCtx , lpDeviceFileID ,0 , lpBuffer , dwFileSize);
    return dwResult ;
}

/**
 * @brief  ڸĿ¼´Ŀ¼ , Ŀ¼ڣĿ¼.
 */

BYTE createSubdirAtRoot( ET_CONTEXT *pCtx ,  LPCSTR lpSubDir , DWORD dwDirSize , LPCSTR lpSubDevPin , LPCSTR lpSubUsrPin , BYTE   bDevPinTryCount  ,  BYTE   bUsrPinTryCount) {
    DWORD dwResult  = 0;
    /**< лĿ¼  */
    dwResult = ETChangeDir( pCtx ,"\\" );
    if (dwResult != 0 ) {
        printf("Change directory [ %s ] failed! <error code: 0x%08x>\n", "\\"  ,dwResult);
        return -1;
    }

    /**< ֤Ŀ¼ĿPIN  */
    dwResult = ETVerifyPin( pCtx , ET_DEFAULT_DEV_PIN, ET_DEV_PIN_LEN, ET_DEV_PIN);
    if ( dwResult != 0 ) {
        printf("Verify the directory [ %s ] DEV_PIN failed! <error code: 0x%08x>\n",  "\\" , dwResult );
        return -1;
    }


    /**< Ŀ¼ , Ŀ¼  */ 
    dwResult = ETChangeDir( pCtx, lpSubDir);
    if (dwResult == 0 ) {
        /**< Ŀ¼еļĿ¼ */
        printf("To erase all the file under %s...\n", lpSubDir);
        dwResult = ETVerifyPin( pCtx,  (unsigned char *)lpSubDevPin , ET_DEV_PIN_LEN , ET_DEV_PIN);
        if (dwResult != 0 ) {
            printf("Verify [ %s ] DEV_PIN failed! <error code: 0x%08x>\n", lpSubDir , dwResult);
            return  -1 ;
        }
        dwResult = ETEraseDir( pCtx , NULL);
        if (dwResult != 0 ) {
            printf("Erase directory [%s] failed! <error code: 0x%08x>\n", lpSubDir, dwResult);
            return -1;
        }

    } else /**< Ŀ¼ "szDirName"*/
    {

        dwResult = ETCreateDir ( pCtx , lpSubDir, dwDirSize  , ET_CREATE_SUB_DIR);
        if (dwResult != 0 ) {
            printf("Create [%s] directory failed! <error code: 0x%08x>\n", lpSubDir , dwResult);
            return -1;
        }

    }

    /**< ڲ򴴽Ŀ¼,޸Ŀ¼ĿPINûPIN ǷǳҪģ */
    dwResult = ETChangePin( pCtx , ET_DEFAULT_USER_PIN , ET_USER_PIN_LEN , (unsigned char *)lpSubUsrPin , ET_USER_PIN_LEN , ET_USER_PIN , bUsrPinTryCount  );
    if (dwResult != 0 ) {
        printf("Change USER_PIN of directory [%s] failed! <error code: 0x%08x>\n", lpSubUsrPin, dwResult);
        return -1;
    }

    dwResult = ETChangePin( pCtx,ET_DEFAULT_DEV_PIN, ET_DEV_PIN_LEN , (unsigned char *)lpSubDevPin , ET_DEV_PIN_LEN , ET_DEV_PIN , bDevPinTryCount );
    if (dwResult != 0) {
        printf("Change DEV_PIN of directory [%s] failed! <error code: 0x%08x>\n", lpSubUsrPin, dwResult);
        return -1;
    }
    return 0 ;

}

