#ifndef __SAMPLE_06_H__
#define __SAMPLE_06_H__

#define CMD_UPDATE_FILE		0x01
#define CMD_READ_FILE		0x02


/**
 * By default, program compiled at PC has the address alignment issues which don't exist in C51 environment.
 * For convenience of data-handling,we use the compact-pack mode for storing the	exchanging data-buffer 
 * used between PC and ET199 device.
 */
#ifdef _WIN32
#pragma pack(push, 1)
typedef double DOUBLE;
#endif 

/**< file context */
typedef struct _VM_FILE_CONTEXT
{
	BYTE bCommand;	  		/*  command type*/
    WORD wFileID ;		   	/*  file ID */
	WORD wOffset  ;		   	/*  access offset */
	BYTE bDataLen  ;	   	/*  data length */
	BYTE pbData[100] ;	   	/*  data */
} VM_FILE_CONTEXT;

/**< read response */
typedef struct _READ_RESPONSE{
    BYTE bRetCode ;
    char  lpBuffer[200] ;
} READ_RESPONSE ;

#ifdef _WIN32
#pragma pack(pop)
#endif


#endif //__SAMPLE_06_H__