#ifndef __SAMPLE_21_H__
#define __SAMPLE_21_H__

#define MAX_DATA_LEN         250

#define CMD_MD5_INIT          0x01
#define CMD_MD5_UPDATE        0x02
#define CMD_MD5_FINAL         0x03

/**
 * By default, program compiled at PC has the address alignment issues which don't exist in C51 environment.
 * For convenience of data-handling,we use the compact-pack mode for storing the exchanging data-buffer 
 * used between PC and ET199 device.
 */
#ifdef _WIN32
#pragma pack(push, 1)
typedef double DOUBLE;
#endif


typedef struct _IO_CONTEXT
{
    BYTE 	bTag;
    BYTE    bDataLen  ;            /*  data length */
    BYTE    pbData[MAX_DATA_LEN]  ; /*  data */

} IO_CONTEXT;


#ifdef _WIN32
#pragma pack(pop)
#endif


#endif //__SAMPLE_21_H__