// TestCom.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ET199Com.h"
#include <iostream>
#include <iomanip>

#define ET_DEV_PIN_LEN	24
#define ET_USER_PIN_LEN	8
#define MAX_ID_LEN		8

using namespace std;

const IID IID_IET199 = {0x526D380A,0xCF44,0x490C,{0xBD,0x4D,0x07,0x56,0x35,0x71,0xAA,0x84}};
const CLSID CLSID_ET199 = {0xDC3A0905,0x248F,0x4E1A,{0x8B,0xD7,0x91,0x6D,0x15,0x0C,0xCC,0x62}};

#define ET_SUCCEEDED(X)	(ET_S_SUCCESS == (X))

void display_et199_error(IET199* pIET199,HRESULT hRet)
{
	USES_CONVERSION;
	BSTR bstrError;	;
	if(ET_SUCCEEDED(pIET199->FormatErrorMessage(hRet,&bstrError)))
	{
		cout << "ET199 exception:" << W2A(bstrError) << endl;
		::SysFreeString(bstrError);
	}
}
void display_device_info(IET199*pIET199)
{
	ULONG ulVal;
	char buffer[250];
	//ӡ汾
	if(ET_SUCCEEDED(pIET199->get_Version(&ulVal)))
	{
		sprintf(buffer , "%d.%02d" , ulVal/256 , (int)((BYTE)ulVal) ) ;
		cout << "Version:\t" << buffer << endl;
	}

	//ӡͻ
	if(ET_SUCCEEDED(pIET199->get_Customer(&ulVal)))
	{
		cout << "Customer:\t";
		cout << hex << setfill('0') << setw(8) << ulVal << endl;
	}
	VARIANT var;
	VariantInit(&var);
	//ӡATR
	if(ET_SUCCEEDED(pIET199->get_AtrLen(&ulVal))
		&& ET_SUCCEEDED(pIET199->get_Atr(&var)))
	{
		BYTE HUGEP* pbData;
		SafeArrayAccessData(var.parray,(VOID HUGEP**)&pbData);
		cout << "Atr:\t\t";
		for(ULONG i=0;i<ulVal;i++)
		{
			cout << pbData[i];
		}
		cout << endl;
		SafeArrayUnaccessData(var.parray);
	}
	//ӡID
	if(ET_SUCCEEDED(pIET199->get_ID(&var)))
	{
		BYTE HUGEP* pbData;
		SafeArrayAccessData(var.parray,(VOID HUGEP**)&pbData);
		cout << "ID:\t\t";
		for(int i=0;i<MAX_ID_LEN;i++)
		{
			cout << hex << setfill('0') << setw(2) << (int)pbData[MAX_ID_LEN-1-i];
		}
		cout << endl;
		SafeArrayUnaccessData(var.parray);
	}
	VariantClear(&var);
}

BOOL WriteExeFileData(IET199* pIET199,BSTR bstrFileID,LPCTSTR lpFilePath,HRESULT& hRet)
{
	USES_CONVERSION;
	hRet = ET_S_SUCCESS;
	HANDLE hFile = CreateFile(lpFilePath,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	if(INVALID_HANDLE_VALUE == hFile)
	{
		cout << "open file: " << W2A(lpFilePath) << " error,error code: " << GetLastError() << endl;
		return FALSE;
	}
	DWORD dwFileSize = GetFileSize(hFile,NULL);
	if(dwFileSize >10240)
	{
		cout << "File size too large!" << endl;
		return FALSE;
	}
	SAFEARRAYBOUND sab;
	sab.lLbound = 0;
	sab.cElements = dwFileSize;

	VARIANT var;
	V_VT(&var) = VT_SAFEARRAY;
	V_ARRAY(&var) = SafeArrayCreate(VT_I1,1,&sab);

	BYTE HUGEP* pbData;
	SafeArrayAccessData(var.parray,(VOID HUGEP**)&pbData);
	ReadFile(hFile,pbData,dwFileSize,&dwFileSize,NULL);
	SafeArrayUnaccessData(var.parray);

	hRet = pIET199->WriteFile(bstrFileID,0,&var,dwFileSize);

	return  ET_SUCCEEDED(hRet);
}

void TestET199Com(IET199* pIET199)
{
	USES_CONVERSION;

	VARIANT defaultDevPin,newDevPin,userPin,commonBuffer1,commonBuffer2;

	SAFEARRAYBOUND sab;
	sab.lLbound = 0;

	sab.cElements = ET_DEV_PIN_LEN;
	V_VT(&defaultDevPin) = VT_SAFEARRAY;
	V_ARRAY(&defaultDevPin) = SafeArrayCreate(VT_I1,1,&sab);

	//sab.cElements = ET_DEV_PIN_LEN;
	V_VT(&newDevPin) = VT_SAFEARRAY;
	V_ARRAY(&newDevPin) = SafeArrayCreate(VT_I1,1,&sab);

	sab.cElements = ET_USER_PIN_LEN;
	V_VT(&userPin) = VT_SAFEARRAY;
	V_ARRAY(&userPin) = SafeArrayCreate(VT_I1,1,&sab);

	sab.cElements = 0x400;
	V_VT(&commonBuffer1) = VT_SAFEARRAY;
	V_ARRAY(&commonBuffer1) = SafeArrayCreate(VT_I1,1,&sab);

	//sab.cElements = 0x400;
	V_VT(&commonBuffer2) = VT_SAFEARRAY;
	V_ARRAY(&commonBuffer2) = SafeArrayCreate(VT_I1,1,&sab);

	//ʼpin
	BYTE HUGEP* pbData;
	SafeArrayAccessData(V_ARRAY(&defaultDevPin),(VOID HUGEP**)&pbData);
	for(int i=0;i<ET_DEV_PIN_LEN;i++)
	{
		pbData[i] = '1'+i%8;
	}
	SafeArrayUnaccessData(V_ARRAY(&defaultDevPin));

	SafeArrayAccessData(V_ARRAY(&newDevPin),(VOID HUGEP**)&pbData);
	for(int i=0;i<ET_DEV_PIN_LEN;i++)
	{
		pbData[i] = '1';
	}
	SafeArrayUnaccessData(V_ARRAY(&newDevPin));

	SafeArrayAccessData(V_ARRAY(&userPin),(VOID HUGEP**)&pbData);
	for(int i=0;i<ET_USER_PIN_LEN;i++)
	{
		pbData[i] = '1'+i%8;
	}
	SafeArrayUnaccessData(V_ARRAY(&userPin));

	//(1)ö豸
	cout << "ö豸..." << endl;
	long lDevCount;	
	HRESULT hRet = pIET199->Enum(&lDevCount);
	if(ET_SUCCEEDED(hRet))
	{
		cout << lDevCount << endl;
		if(0 == lDevCount)return;
	}
	else
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(2)豸0
	cout << "\n豸0..." << endl;
	hRet = pIET199->Open(0);
	if(ET_SUCCEEDED(hRet))
	{
		display_device_info(pIET199);
	}
	else
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	
	//(3)лĿ¼
	cout << "\nлĿ¼..."<< endl;
	hRet = pIET199->ChangeDir(L"\\");
	if(ET_SUCCEEDED(hRet))
	{
		//(4)֤pin
		cout << "\n֤pin..." << endl;
		hRet = pIET199->VerifyPin(&defaultDevPin,ET_DEV_PIN);
		if(!ET_SUCCEEDED(hRet))
		{
			display_et199_error(pIET199,hRet);
			goto FAIL;
		}

		//(5)ɾĿ¼
		cout << "\nɾĿ¼..." << endl;
		hRet = pIET199->EraseDir(NULL);
		if(!ET_SUCCEEDED(hRet))
		{
			display_et199_error(pIET199,hRet);
			goto FAIL;
		}
	}
	else
	{
		display_et199_error(pIET199,hRet);
		if(ET_E_DIR_NOT_FOUND != hRet)
		{
			goto FAIL;
		}
	}
	//(6)Ŀ¼
	cout << "\nĿ¼..." << endl;
	hRet = pIET199->CreateDir(L"\\",0,ET_ROOT_DIR);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(7)֤pin
	cout << "\n֤pin..." << endl;
	hRet = pIET199->VerifyPin(&defaultDevPin,ET_DEV_PIN);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(8)LED˸
	const DWORD dwLedFreq = 5;
	SafeArrayAccessData(V_ARRAY(&commonBuffer1),(VOID HUGEP**)&pbData);
	*(DWORD*)pbData = dwLedFreq;
	SafeArrayUnaccessData(V_ARRAY(&commonBuffer1));
	hRet = pIET199->Control(ET_LED_WINK,&commonBuffer1,sizeof(DWORD),NULL,NULL);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(9)Ŀ¼
	BSTR bstrDirID = L"5678";
	cout << "\nĿ¼,IDΪ" << W2A(bstrDirID) << "..." << endl;
	hRet = pIET199->CreateDir(bstrDirID,0x2000,ET_SUB_DIR);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(10)Ŀpin
	cout << "\nĿpin..." << endl;
	hRet = pIET199->ChangePin(&defaultDevPin,&newDevPin,ET_DEV_PIN,0xFF);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(11)һִļ
	BSTR bstrExeFileID = L"1234";
	cout << "\nһִļ,IDΪ:" << W2A(bstrExeFileID) << "..." << endl;
	hRet = pIET199->CreateFile(bstrExeFileID,0x1000,FILE_TYPE_EXE);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(12)дݵִļ
	cout << "\nдݵִļ" << W2A(bstrExeFileID) << "..." << endl;
	if(!WriteExeFileData(pIET199,bstrExeFileID,L"hardware\\hardware.bin",hRet))
	{
		if(!ET_SUCCEEDED(hRet))
		{
			display_et199_error(pIET199,hRet);
		}
		goto FAIL;
	}
	//(13)֤ûpin
	cout << "\n֤ûpin..." << endl;
	hRet = pIET199->VerifyPin(&userPin,ET_USER_PIN);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(14)пִг
	cout << "\nпִг" << W2A(bstrExeFileID) << "..." << endl;
	long lBytesReturn;
	hRet = pIET199->Execute(bstrExeFileID,NULL,0,&commonBuffer1,&lBytesReturn);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(15)ȡļϢ
	SafeArrayAccessData(commonBuffer1.parray,(VOID HUGEP**)&pbData);
	pbData[0] = '1';
	pbData[1] = '2';
	pbData[2] = '3';
	pbData[3] = '4';
	SafeArrayUnaccessData(commonBuffer1.parray);
	long nRetLen;
	cout << "\nȡļϢ..." << endl;
	hRet = pIET199->Control(ET_GET_EF_INFO,&commonBuffer1,4,&commonBuffer1,&nRetLen);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(16)֤pin
	cout << "\n֤pin..." << endl;
	hRet = pIET199->VerifyPin(&newDevPin,ET_DEV_PIN);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(17)Կ
	cout << "\nԿ..." << endl;
	hRet = pIET199->GenerateRsaKey(1024,0x10001,L"1111",L"2222",&commonBuffer1,&commonBuffer2);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(18)лһĿ¼
	cout << "\nлһĿ¼..." << endl;
	hRet = pIET199->ChangeDir(L"..");
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}

	//(19)豸
	cout << "\n豸..." << endl;
	hRet = pIET199->Control(ET_RESET_DEVICE,NULL,0,NULL,NULL);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(20)֤pin
	cout << "\n֤pin..." << endl;
	hRet = pIET199->VerifyPin(&defaultDevPin,ET_DEV_PIN);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(21)ɾĿ¼
	cout << "\nɾĿ¼..." << endl;
	hRet = pIET199->EraseDir(NULL);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}	
	//(22)Ŀ¼
	cout << "\nĿ¼..." << endl;
	hRet = pIET199->CreateDir(L"\\",0,ET_ROOT_DIR);
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
	//(23)ر豸
	cout << "\nر豸..." << endl;
	hRet = pIET199->Close();
	if(!ET_SUCCEEDED(hRet))
	{
		display_et199_error(pIET199,hRet);
		goto FAIL;
	}
FAIL:
	VariantClear(&defaultDevPin);
	VariantClear(&newDevPin);
	VariantClear(&userPin);
	VariantClear(&commonBuffer1);
	VariantClear(&commonBuffer2);
	getchar();
}

int _tmain(int argc, _TCHAR* argv[])
{
	HRESULT hRet = CoInitialize(0);
	if(SUCCEEDED(hRet))
	{
		IET199* IFirstATL;
		hRet = CoCreateInstance( CLSID_ET199, NULL, 
			CLSCTX_INPROC_SERVER,
			IID_IET199, (void**) &IFirstATL);
		if(SUCCEEDED(hRet))
		{			
			cout << "ET199 Test Begin...\n"<<endl;
			TestET199Com(IFirstATL);
			cout << "\nET199 Test End" << endl;
			IFirstATL->Release(); 
		}
		else
		{
			cout << "CoCreateInstance Failed." << endl;
		}
	}
	// жCOM
	CoUninitialize();
}

